using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CSharpDemo
{
    public partial class CSharpDemo : Form
    {
        //ֵתΪʮַ
        private byte[] StrToByetArray(string hexValues)
        {
            string[] hexValuesSplit = hexValues.Split(' ');
            byte[] retBytes = new byte[hexValuesSplit.Length];

            for (int nLoop = 0; nLoop < retBytes.Length; nLoop++)
            {
                retBytes[nLoop] = Convert.ToByte(hexValuesSplit[nLoop], 16);
            }

            return retBytes;
        }

        //ַתΪʮ
        private byte[] StrToByetArray(string[] hexValues, int nLen)
        {
            byte[] retBytes = new byte[nLen];

            for (int nLoop = 0; nLoop < retBytes.Length; nLoop++)
            {
                retBytes[nLoop] = Convert.ToByte(hexValues[nLoop], 16);
            }

            return retBytes;
        }

        //ʮַתΪֵ
        private string ByteArrayToStr(byte[] byteArray, bool bNeedFormat, int nStart, int nEnd)
        {
            //nEndΪ0ת

            string strReturn = "";

            if (bNeedFormat)
            {
                strReturn = "\r\nHEX RESULT:";
            }

            int nLoop = 0;
            nLoop += nStart;
            if(nEnd == 0)
            {
                nEnd = byteArray.GetLength(0);
            }
            else if(nEnd > byteArray.GetLength(0))
            {
                nEnd = byteArray.GetLength(0);
            }
            

            for (; nLoop < nEnd; nLoop++)
            {
                string strHex = "";

                if (bNeedFormat)
                {
                    if (nLoop % 16 != 0)
                    {
                        strHex = string.Format(" {0:X2}", byteArray[nLoop]);
                    }
                    else
                    {
                        strHex = string.Format("\r\n  {0:X2}...{1:X2}", nLoop / 16, byteArray[nLoop]);
                    }
                }
                else
                {
                    strHex = string.Format(" {0:X2}", byteArray[nLoop]);
                }

                strReturn += strHex;
            }

            return strReturn;
        }

        //־ı
        private void WriteLog(string strText, int nRet,string strErrcode)
        {
            if (nRet != 0)
            {
                textRespons.Text += System.DateTime.Now.ToLocalTime().ToString() + " " + strText + "\r\n" + strErrcode + "\r\n";
            }
            else
            {
                textRespons.Text += System.DateTime.Now.ToLocalTime().ToString() + " " + strText + " " +  "\r\n";
            }

            textRespons.Select(textRespons.TextLength, 0);//궨λı
            textRespons.ScrollToCaret();//괦
        }

        //ת
        private string FormatErrorCode(byte[] byteArray)
        {
            string strErrorCode = "";
            switch (byteArray[0])
            {
                case 0x80:
                    strErrorCode = "Success";
                    break;
                    
                case 0x81:
                    strErrorCode = "Parameter Error";
                    break;

                case 0x82:
                    strErrorCode = "communication TimeOut";
                    break;

                case 0x83:
                    strErrorCode = "Couldn't Find Card ";
                    break;
                    
                default:
                    strErrorCode = "Commond Error";
                    break;                    
            }

            return strErrorCode;
        }

        //ַȡַǷո񣬾ַΪһ
        private string[] strCutLength(string str, int iLength)
        {
            string[] reslut = null;
            if (!string.IsNullOrEmpty(str))
            {
                int iTemp = 0;
                string strTemp = null;
                System.Collections.ArrayList strArr = new System.Collections.ArrayList();
                for (int i = 0; i < str.Length; i++)
                {
                    if (str[i] == ' ')
                    {
                        continue;
                    }
                    else
                    {
                        iTemp++;
                        strTemp += str.Substring(i, 1);
                    }

                    //УȡַǷA~F0~9
                    System.Text.RegularExpressions.Regex reg = new System.Text.RegularExpressions.Regex(@"^(([A-F])*(\d)*)$");
                    if (!reg.IsMatch(strTemp))
                    {
                        return reslut;
                    }

                    if ((iTemp == iLength) || (i == str.Length - 1 && !string.IsNullOrEmpty(strTemp)))
                    {
                        strArr.Add(strTemp);
                        iTemp = 0;
                        strTemp = null;
                    }
                }
                if (strArr.Count > 0)
                {
                    reslut = new string[strArr.Count];
                    strArr.CopyTo(reslut);
                }
            }
            return reslut;
        }

        public CSharpDemo()
        {
            InitializeComponent();
        }

        private void CSharpDemo_Load(object sender, EventArgs e)
        {
            cbReadFlag.SelectedIndex = 1;
            cbWriteFlag.SelectedIndex = 1;
        }

        /*˫Ϣչʾ*/
        private void textRespons_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            textRespons.Text = "";
        }

        /*öк*/
        private void btnSetSerNum_Click(object sender, EventArgs e)
        {
            byte[] byteRet = new byte[1];
            string strErrorCode = "";
            string[] reslut = strCutLength(textSetSerNum.Text.ToUpper(), 2);

            if (reslut == null)
            {
                MessageBox.Show("Input is not a valid integer value");
                return;
            }
            else if (reslut.GetLength(0) < 8)
            {
                MessageBox.Show("Input is not 8 byte");
                return;
            }

            byte[] byteBuffer = StrToByetArray(reslut, 8);

            int nRet = MiReader.SetSerNum(byteBuffer,byteRet );

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteRet);

                WriteLog("Set Serial Number Error", nRet, strErrorCode);
            }
            else
            {
                string strText = "";
                for (int nLoop = 0; nLoop < 8; nLoop++)
                {
                    if (reslut[nLoop].Length == 1)
                    {
                        strText += "0" + reslut[nLoop] + " ";
                    }
                    else
                    {
                        strText += reslut[nLoop] + " ";
                    }
                }

                WriteLog("Set Serial Number" + strText, nRet, strErrorCode);
            }
        }

        /*ȡк*/
        private void btnReadSerNum_Click(object sender, EventArgs e)
        {
            byte[] byteArry = new byte[9];
            string strErrorCode = "";

            int nRet = MiReader.GetSerNum(byteArry);

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteArry);

                WriteLog("Get Serial Number Error", nRet, strErrorCode);
            }
            else
            {
                WriteLog("Get Serial Number " + ByteArrayToStr(byteArry, false,1, 0), nRet,"");

                textSerNum.Text = ByteArrayToStr(byteArry, false, 1, 0);
            }
        }

        /*ȡ汾*/
        private void btnGetVersionNum_Click(object sender, EventArgs e)
        {
            byte[] byteArry = new byte[11];
            string strErrorCode = "";

            int nRet = MiReader.GetVersionNum(byteArry);

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteArry);

                WriteLog("Get Version Number Error", nRet, strErrorCode);
            }
            else
            {
                WriteLog("Get VersionNum" + ByteArrayToStr(byteArry, false, 0, 0), nRet, "");

                textReaderVers.Text = ByteArrayToStr(byteArry, false, 0, 0);
            }
        }

        /*ʾ*/
        private void btnSetLed_Click(object sender, EventArgs e)
        {
            //string strRet = "";
            byte[] byteRet = new byte[1];
            string strErrorCode = "";

            int nRet = MiReader.ControlLED(byteRet);

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteRet);

                WriteLog("Mistake Hints Error", nRet, strErrorCode);
            }
            else
            {
                WriteLog("Mistake Hints", nRet, "");
            }          
        }

        /*ȷʾ*/
        private void btnSetBuzzer_Click(object sender, EventArgs e)
        {
            byte[] byteRet = new byte[1];
            string strErrorCode = "";

            int nRet = MiReader.ControlBuzzer(byteRet);

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteRet);

                WriteLog("Succeed Hints Error", nRet, strErrorCode);
            }
            else
            {
                WriteLog("Succeed Hints", nRet, strErrorCode);
            }
        }

        /*ͻ*/
        private void btnInventory_Click(object sender, EventArgs e)
        {
            byte[] byteCardnumber = new byte[1];
            byte[] byteBuffer = new byte[256];
            string strErrorCode = "";

            int nRet = MiReader.ISO15693_Inventory(byteCardnumber, byteBuffer);

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteCardnumber);

                WriteLog("Inventory Error", nRet, strErrorCode);
            }
            else
            {
                //־չʾϢ
                string strText = "";

                //ȡÿ
                string strCardNum = ByteArrayToStr(byteCardnumber, false, 0, 0);
                //int nCardNum = 1;

                strText += "Inventory" + "\r\n" + "Card Num is:" + strCardNum + "\r\n";

                //ȡÿţȥλʶλ
                strText += "Card No:" ;

                for (int nLoop = 0; nLoop < byteCardnumber[0]; nLoop++)
                {
                    strText += ByteArrayToStr(byteBuffer, false, nLoop * 8 + 2, (nLoop + 1) * 8 + 2) + "\r\n";
                }

               WriteLog(strText, nRet, strErrorCode);
            }
        }

        /**/
        private void btnRead_Click(object sender, EventArgs e)
        {
            byte[] byteuid = new byte[256];
            byte[] byteBuffer = new byte[256];
            string strErrorCode = "";

            string strFlag = "";
            int nFlag = 0;//Ͳһ0x42ֵȫ״ֽ̬ڣ0x02ֵȫ״ֽ̬

            if (cbReadFlag.SelectedIndex == 0)
            {
                strFlag = "42";
                nFlag = 1;
            }
            else
            {
                strFlag = "02";
            }

            int nRet = MiReader.ISO15693_Read(Convert.ToByte(strFlag),
                                             Convert.ToByte(textReadArea.Text),
                                             Convert.ToByte(textReadNum.Text),
                                             byteuid,
                                             byteBuffer);

            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteBuffer);

                WriteLog("Read Card Error", nRet, strErrorCode);
            }
            else
            {
                string strText = "";
                int nCardNum = Convert.ToInt32(textReadNum.Text);
                strText += "Read Card:" + "\r\n";

                //UIDչʾҪתstrUIDɲִ
                //string strUID = ByteArrayToStr(byteuid, false, 0, 0);
                
                for (int nLoop = 0; nLoop < nCardNum; nLoop++)
                {
                    strText += ByteArrayToStr(byteBuffer, false, nLoop * (4 + nFlag) + nFlag + 1, (nLoop + 1) * (4 + nFlag) + nFlag + 1) + "\r\n";
                }

                WriteLog(strText, nRet, strErrorCode);
            }
        }

        /*д*/
        private void btnWrite_Click(object sender, EventArgs e)
        {
            byte[] byteuid = new byte[256];
            string strErrorCode = "";
            string strFlag = "";
            string[] reslut = strCutLength(textWriteData.Text.ToUpper(), 2);

            if (reslut == null)
            {
                MessageBox.Show("Input is not a valid integer value");
                return;
            }
            else if (reslut.GetLength(0) < 4)
            {
                MessageBox.Show("Input is not 4 byte");
                return;
            }

            byte[] byteBuffer = StrToByetArray(reslut, 4);

            if (cbReadFlag.SelectedIndex == 0)
            {
                strFlag = "42";
            }
            else
            {
                strFlag = "02";
            }

            int nRet = MiReader.ISO15693_Write(Convert.ToByte(strFlag),
                                             Convert.ToByte(textWriteArea.Text),
                                             Convert.ToByte(textWriteNum.Text),
                                             byteuid,
                                             byteBuffer);


            if (nRet != 0)
            {
                strErrorCode = FormatErrorCode(byteBuffer);

                WriteLog("Read Card Error", nRet, strErrorCode);
            }
            else
            {
                string strText = "";
                for (int nLoop = 0; nLoop < 4; nLoop++)
                {
                    if (reslut[nLoop].Length == 1)
                    {
                        strText += "0" + reslut[nLoop] + " ";
                    }
                    else
                    {
                        strText += reslut[nLoop] + " ";
                    }
                }

                WriteLog("Write Card" + strText, nRet, strErrorCode);
            }
        }

        private void btnGetReaderVerEx_Click(object sender, EventArgs e)
        {

        }

        private void btnInventoryEx_Click(object sender, EventArgs e)
        {

        }

        private void btnOpenRF_Click(object sender, EventArgs e)
        {

        }

        private void btnCloseRF_Click(object sender, EventArgs e)
        {

        }
    }
}